



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>dfs+剪枝：poj2362</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">dfs+剪枝：poj2362</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 21:05:11 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>贴题目</p>
<div>Square</div>
<div>
<table>
<tbody>
<tr>
<td><strong>Time Limit:</strong>&nbsp;3000MS</td>
<td>&nbsp;</td>
<td><strong>Memory Limit:</strong>&nbsp;65536K</td>
</tr>
<tr>
<td><strong>Total Submissions:</strong>&nbsp;24604</td>
<td>&nbsp;</td>
<td><strong>Accepted:</strong>&nbsp;8449</td>
</tr>
</tbody>
</table>
</div>
<p>Description</p>
<div>Given a set of sticks of various lengths, is it possible to join them end-to-end to form a square?</div>
<p>Input</p>
<div>The first line of input contains N, the number of test cases. Each test case begins with an integer 4 &lt;= M &lt;= 20, the number of sticks. M integers follow; each gives the length of a stick - an integer between 1 and 10,000.</div>
<p>Output</p>
<div>For each case, output a line containing "yes" if is is possible to form a square; otherwise output "no".</div>
<div>&nbsp;</div>
<div>一道和1011很像的剪枝，在做了1011之后我写了这道题，结果不幸的wa了。所以说，1011的测点很水QAQ</div>
<div>读题后发现以下剪枝：</div>
<div>1、如果所有木棍和加起来不能被4整除，那么不能构成square;</div>
<div>2、将所有木棍和除以4的值（边长）保存，如果子段中的最大长度大于这一值，那么不能构成square;</div>
<div>3、与1011同理，同一长度的木棍不需重复判断；</div>
<div>4、将木棍从大到小开始找，因为越小的木棍灵活度越高。</div>
<div>分析可知，如果已经构成了3条边符合要求，那么一定能构成一个正方形。所以在进行第四边查找时，我们可以直接确定可以构成正方形。</div>
<div>代码如下：</div>
<div>
<div>
<pre class="prettyprint linenums">#include&lt;cstdio&gt;<br />
#include&lt;algorithm&gt;<br />
#include&lt;cstring&gt;<br />
bool flag,zt[];<br />
int n,m,a[],sum,l,mm,i;<br />
using namespace std;<br />
bool cmp(const int a,const int b){<br />
    return a&gt;b;<br />
}<br />
void dfs(int num,int len,int now){<br />
    if(flag)return ;<br />
    if(num==){<br />
        flag=true;<br />
        return;<br />
    }<br />
    if(len==sum){<br />
        dfs(num+,,);<br />
        if(flag)return ;<br />
    }<br />
    int i;<br />
    for(i = now; i &lt;= mm ; ++i){<br />
        if(!zt[i]&amp;&amp;len+a[i]&lt;=sum){<br />
            zt[i]=true;<br />
            dfs(num,len+a[i],i+);<br />
            zt[i]=false;<br />
            if(flag)return ;<br />
        }<br />
    }<br />
    return ;<br />
}<br />
void start(){<br />
    sum=;<br />
    memset(a,,sizeof(a));<br />
    flag=false;<br />
    i=;<br />
}<br />
int main(){<br />
    scanf("%d",&amp;n);<br />
    while(n--){<br />
        start();<br />
        scanf("%d",&amp;m);<br />
         mm=m;<br />
        while(m--){<br />
            ++i;<br />
            scanf("%d",&amp;a[i]),sum+=a[i];<br />
        }<br />
        sort(a+,a+mm+,cmp);<br />
        if(sum%||a[]&gt;sum){<br />
            printf("no\n");<br />
            continue;<br />
        }<br />
        sum/=;<br />
        memset(zt,,sizeof(zt));<br />
        dfs(,,);<br />
        if(flag)printf("yes\n");<br />
        else printf("no\n");<br />
    }<br />
    return ;<br />
}<br />dfs的习题重要的就是剪枝，拿到题目一定要多分析，尽可能多地找出不必要的枝，来提高时间效率。博主自己还要注意的就是细心，总是出一些没有必要的小毛病，希望能改掉这个毛病。<br />今天写的比较匆忙，不足的地方麻烦大家帮我提出来了~嗯，以后还是要加强练习。</pre>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwvrpz8.html">Oracle 创建普通用户，并赋予权限</a>
		</li>
						<li><a href="https://www.batexi.com/a/390pgej8.html">bzoj3316&colon; JC loves Mkk</a>
		</li>
						<li><a href="https://www.batexi.com/a/390440o8.html">数据库、数据表的创建SP2</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7yjgkq.html">C&plus;&plus;指针比较的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q27xmo8.html">Apache Spark源码走读之15 -- Standalone部署模式下的容错性分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdew0lz9.html">OpenJudge计算概论-四大湖</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdwz4r8.html">Spring init-method and destroy-method example</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdyzjr8.html">android 29   ArrarAdapter数组适配器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd642r8.html">jQuery学习-事件之绑定事件（六）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpp5z7q.html">fedora linux平台下搭建lighttpd&plus;php&plus;sqlite</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zorgvnq.html">深入浅出Ajax（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljkxne9.html">Codeforces Round &num;392 &lpar;Div&period; 2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv17gp1q.html">hibernate使用setResultTransformer&lpar;&rpar;将SQL查询结果放入集合中</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj7gzx9.html">洛谷 &lbrack;P1220&rsqb; 关路灯</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1wo11q.html">23 广播服务结合音乐Demo5</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m31e38.html">HTML 练习实现鼠标移到用户图像展示更多信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv16looq.html">js获取时间相关函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyo34v9.html">最大矩阵（简单DP）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r51verq.html">sping加载bean都发生了些什么</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r5yko9.html">&lbrack;No0000162&rsqb;如何不靠运气致富&vert;来自硅谷著名天使投资人的40条致富经</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9jzljr48.html">Swift组合逻辑</a>
			</li>
						<li><a href="https://www.batexi.com/a/950drlz8.html">javascript实现禁止右键和F12查看源代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjw15g8.html">CSS学习笔记08 浮动</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg7d7d8.html">php通过curl扩展进行模拟登录（含验证码）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjwd438.html">&lbrack;leetcode-566-Reshape the Matrix&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pd3dj8.html">对X86汇编的理解与入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mekdw2q.html">JAVA - 深入JAVA 虚拟机 2</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzlew48.html">Mac之OS系统下搭建JavaEE环境 &amp;lt&semi;二&amp;gt&semi; 之Tomcat 的安装配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojyvz5q.html">synchronized的作用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg70md8.html">java多线程系列&lpar;二&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
